## holmes-4.0.tar.gz

=== Makefile ===
# Makefile for the Sherlock Search System
# (c) 1997--2007 Martin Mares <mj@ucw.cz>

# The default target
all: runtree programs api datafiles extras configs

# Include configuration
s=.
-include obj/config.mk
obj/config.mk:
	@echo 'You have to run configure first.'
	@exit 1

BUILDSYS=$(s)/build

# We will use the libucw makefile system
include $(BUILDSYS)/Maketop

# Custom clean rules
distclean::
	rm -f custom

# Configuration files
ifdef CONFIG_SHERLOCK
CONFIGS+=accept filter sherlock local url-equiv trace
endif

# Extra directories to be created in the run/* hierarchy
EXTRA_RUNDIRS+=lock lib/perl5/Sherlock
ifdef CONFIG_SHERLOCK
EXTRA_RUNDIRS+=db cache index
endif

# We need to define names of libraries here, because even though variable references
# in bodies of rules can be forward, those in dependencies cannot. Also the order of
# includes is somewhat fragile because of that.
LIBSH=$(o)/sherlock/libsh.pc
LIBSHXML=$(o)/sherlock/xml/libshxml.pc
LIBCUSTOM=$(o)/sherlock/libcustom.pc
LIBCHARSET=$(o)/charset/libcharset.pc
LIBFILTER=$(o)/filter/libfilter.pc
LIBINDEXER=$(o)/indexer/libindexer.pc
LIBLANG=$(o)/lang/liblang.pc
LIBIMAGES=$(o)/images/libimages.pc
LIBANAL=$(o)/analyser/libanalyser.pc
LIBGATH=$(o)/gather/libgather.pc
LIBPROTO=$(o)/gather/proto/libproto.pc
LIBPARSE=$(o)/gather/format/libparse.pc
LIBSHEP=$(o)/gather/shepherd/libshepherd.pc

# All tests (%-t) get automatically linked with libsh or libucw
ifdef CONFIG_SHERLOCK_LIB
TESTING_DEPS=$(LIBSH)
else
TESTING_DEPS=$(LIBUCW)
endif

# Include makefiles of various subsystems
-include custom/Makefile
include $(BUILDSYS)/Makefile
include $(s)/ucw/Makefile
ifdef CONFIG_SHERLOCK_LIB
include $(s)/sherlock/Makefile
endif
ifdef CONFIG_CHARSET
include $(s)/charset/Makefile
endif
ifdef CONFIG_LIBLANG
include $(s)/lang/Makefile
endif
ifdef CONFIG_IMAGES
include $(s)/images/Makefile
endif

ifdef CONFIG_SHERLOCK
include $(s)/filter/Makefile
include $(s)/utils/Makefile
include $(s)/analyser/Makefile
include $(s)/gather/Makefile
ifdef CONFIG_ADMIN
include $(s)/centrum/admin/Makefile
endif
include $(s)/indexer/Makefile
ifdef CONFIG_SEARCH
include $(s)/search/Makefile
endif
ifdef CONFIG_DEBUG_TOOLS
include $(s)/debug/Makefile
endif
endif

# Build documentation by default?
ifdef CONFIG_DOC
all: docs
endif

# Installation

ifdef CONFIG_SHERLOCK
# If we build full Sherlock, we use our own install script which just copies
# selected parts of the runtree hierarchy.
install: all
	SH_EXTRA_RUNDIRS="$(sort $(EXTRA_RUNDIRS))" SH_INSTALL_RUNDIRS="$(sort $(INSTALL_RUNDIRS))" SH_CONFIGS="$(sort $(CONFIGS))" SH_AUTO_CONFIRM="$(CONFIRM)" $(BUILDSYS)/installer $(INSTALL_DIR)

else
ifndef CONFIG_LOCAL
# If we build only the libraries, we hand the work over to their local installation
# targets, which work in the traditional UNIXy way.
install: all $(INSTALL_TARGETS)
else
install:
	@echo "Nothing to install, this is a local build." && false
endif
endif

# We prefer configuration files defined by the customizaton over the generic versions
run/$(CONFIG_DIR)/%: custom/cf/% $(o)/config.mk $(BUILDSYS)/genconf
	$(M)CF $<
	$(Q)$(BUILDSYS)/genconf $< $@ $(o)/config.mk

include $(BUILDSYS)/Makebottom

=== analyser/Makefile ===
# Makefile for the Sherlock Analysers (c) 2007 Martin Mares <mj@ucw.cz>

DIRS+=analyser

ifdef CONFIG_ANALYSER

CONFIGS+=analyser

LIBANAL_MODS=analyser a-test a-iprange a-substr
LIBANAL_DEPS=

ifdef CONFIG_LANG
LIBANAL_MODS+=a-lang
LIBANAL_DEPS+=$(LIBLANG)
endif

ifneq ($(CONFIG_IMAGES_DUP)$(CONFIG_IMAGES_SIM),)
LIBANAL_MODS+=a-imagesig
LIBANAL_DEPS+=$(LIBIMAGES)
endif

$(o)/analyser/libanalyser.a: $(addsuffix .o,$(addprefix $(o)/analyser/,$(LIBANAL_MODS)))
$(o)/analyser/libanalyser.so: $(addsuffix .oo,$(addprefix $(o)/analyser/,$(LIBANAL_MODS)))
$(o)/analyser/libanalyser.pc: $(LIBSH) $(LIBANAL_DEPS) $(LIBCHARSET)

PROGS+=$(o)/analyser/atest

$(o)/analyser/atest: $(o)/analyser/atest.o $(LIBANAL) $(LIBSH)

TESTS+=$(addprefix $(o)/analyser/,a-substr.test a-iprange.test)

$(o)/analyser/a-substr.test: $(o)/analyser/atest
$(o)/analyser/a-iprange.test: $(o)/analyser/atest

API_LIBS+=libanalyser
run/lib/pkgconfig/libanalyser.pc: $(o)/analyser/libanalyser.pc

endif

=== debug/Makefile ===
# Debugging utilities which are intended solely for authors' internal use

DIRS+=debug
PROGS+=$(addprefix $(o)/debug/,\
	whenis sample cols histogram random-access hex \
	log-times log-qsplit log-ssstats \
	find-cycles mkgraphidx find-unreachable visualize-site compare-lang count-domains)

$(o)/debug/random-access: $(o)/debug/random-access.o $(LIBSH)
$(o)/debug/sample: $(o)/debug/sample.o $(LIBSH)
$(o)/debug/histogram: $(o)/debug/histogram.o $(LIBSH)
$(o)/debug/flashdis: $(o)/debug/flashdis.o $(LIBSH)
$(o)/debug/ffstest: $(o)/debug/ffstest.o $(LIBSH)
$(o)/debug/refs-analyse: $(o)/debug/refs-analyse.o $(o)/indexer/iconfig.o $(LIBSH) -lm
$(o)/debug/bmap: $(o)/debug/bmap.o $(LIBSH)
$(o)/debug/mkgraphidx: $(o)/debug/mkgraphidx.o $(LIBSH)
$(o)/debug/noop: $(o)/debug/noop.o $(LIBUCW)
$(o)/debug/noop: LIBS+=-lpthread
$(o)/debug/find-unreachable: $(o)/debug/find-unreachable.o $(LIBINDEXER) $(LIBSH)
$(o)/debug/cachesim: $(o)/debug/cachesim.o $(LIBUCW)
$(o)/debug/shdd: $(o)/debug/shdd.o $(LIBUCW)
$(o)/debug/shot-answer-urls: $(s)/debug/shot-answer-urls.pl
$(o)/debug/shot-stats: $(o)/debug/shot-stats.o $(LIBSH)
$(o)/debug/visualize-site: $(s)/debug/visualize-site.pl
$(o)/debug/compare-lang: $(o)/debug/compare-lang.o $(LIBINDEXER) $(LIBLANG) $(LIBSH)
$(o)/debug/count-domains: $(s)/debug/count-domains.pl
$(o)/debug/hex: $(o)/debug/hex.o $(LIBUCW)

ifdef CONFIG_WEIGHTS
PROGS+=$(o)/debug/pagerank
$(o)/debug/pagerank: $(o)/debug/pagerank.o $(LIBINDEXER) $(LIBSH)
endif

include $(s)/debug/sorter/Makefile

=== filter/Makefile ===
# Makefile for the Sherlock Filter Language (c) 2001--2007 Martin Mares <mj@ucw.cz>

DIRS+=filter
PROGS+=$(o)/filter/filter-test

LIBFILTER_MODS=lex parse.tab filter prune builtin hashes kmp tries trees dumper fconfig
LIBFILTER_INCLUDES=filter.h

$(o)/filter/libfilter.a: $(addsuffix .o,$(addprefix $(o)/filter/,$(LIBFILTER_MODS)) $(CUSTOM_FILTER_MODULES))
$(o)/filter/libfilter.so: $(addsuffix .oo,$(addprefix $(o)/filter/,$(LIBFILTER_MODS)) $(CUSTOM_FILTER_MODULES))
$(o)/filter/libfilter.pc: $(LIBSH)

$(o)/filter/ftest: $(o)/filter/ftest.o $(LIBFILTER) $(LIBSH)
$(o)/filter/filter-test: $(o)/filter/filter-test.o $(LIBFILTER) $(LIBSH)
$(o)/filter/filter-example: $(o)/filter/filter-example.o $(LIBFILTER) $(LIBSH)

$(o)/filter/parse.tab.o $(o)/filter/parse.tab.oo: CWARNS+=-Wno-sign-compare -Wno-redundant-decls -Wno-undef
$(o)/filter/lex.o $(o)/filter/lex.oo: CWARNS+=-Wno-sign-compare -Wno-redundant-decls -Wno-missing-prototypes -Wno-unused-function -Wno-undef

$(addsuffix .o,$(addprefix $(o)/filter/,$(LIBFILTER_MODS))) \
$(addsuffix .oo,$(addprefix $(o)/filter/,$(LIBFILTER_MODS))): $(o)/filter/parse.tab.h

$(o)/filter/parse.tab.h: $(o)/filter/parse.tab.c
	$(Q)touch $@

$(o)/filter/parse.tab.c: $(s)/filter/parse.y
	$(M)BISON $^
	$(Q)bison -dv $^ -o $@

$(o)/filter/lex.c: $(s)/filter/lex.l
	$(M)FLEX $^
	$(Q)flex -s -B -8 -o$@ $^

API_LIBS+=libfilter
API_INCLUDES+=$(o)/filter/.include-stamp
$(o)/filter/.include-stamp: $(addprefix $(s)/filter/,$(LIBFILTER_INCLUDES))
$(o)/filter/.include-stamp: IDST=filter
run/lib/pkgconfig/libfilter.pc: $(o)/filter/libfilter.pc

=== gather/Makefile ===
# Makefile for the Sherlock Gatherer (c) 2001--2006 Martin Mares <mj@ucw.cz>

DIRS+=gather

ifdef CONFIG_GATHERER

PROGS+=$(o)/gather/gtest $(o)/gather/gbatch
CONFIGS+=gatherer checker checker-filter

LIBGATH_MODS=ginit gobject gconfig charset content gfilter bucket diff ganalyse \
        ctmatch
LIBGATH_INCLUDES=gather.h

include $(s)/gather/proto/Makefile
include $(s)/gather/format/Makefile

$(o)/gather/libgather.a: $(addsuffix .o,$(addprefix $(o)/gather/,$(LIBGATH_MODS)))
$(o)/gather/libgather.so: $(addsuffix .oo,$(addprefix $(o)/gather/,$(LIBGATH_MODS)))
$(o)/gather/libgather.pc: $(LIBSH) $(LIBLANG) $(LIBANAL) $(LIBCHARSET) $(LIBFILTER)

$(o)/gather/gtest: $(o)/gather/gtest.o $(LIBPARSE) $(LIBPROTO) $(LIBGATH) $(LIBSH)
$(o)/gather/gbatch: $(o)/gather/gbatch.o $(LIBPARSE) $(LIBPROTO) $(LIBGATH) $(LIBSH)

API_LIBS+=libgather
API_INCLUDES+=$(o)/gather/.include-stamp
$(o)/gather/.include-stamp: $(addprefix $(s)/gather/,$(LIBGATH_INCLUDES))
$(o)/gather/.include-stamp: IDST=gather
run/lib/pkgconfig/libgather.pc: $(o)/gather/libgather.pc

ifdef CONFIG_GATHERD
include $(s)/gather/daemon/Makefile
endif

endif

ifdef CONFIG_SHEPHERD_PROTOCOL
include $(s)/gather/shepherd/Makefile
endif

=== indexer/Makefile ===
# Makefile for the Sherlock Indexer (c) 2001--2004 Martin Mares <mj@ucw.cz>

DIRS+=indexer

ifdef CONFIG_INDEXER

PROGS+=$(addprefix $(o)/indexer/,indexer scanner merger labelsort mklex \
chewer wsort ssort psort lexorder lexsort lexfreq seal black-gen attrsort export-feedback)
CONFIGS+=indexer

ifndef CONFIG_BARE
PROGS+=$(addprefix $(o)/indexer/,mergesums mergesigns keywords mergefp ireport reftexts \
backlinker mkgraph fpsort)
endif

ifdef CONFIG_SITES
PROGS+=$(o)/indexer/sitefinder
$(o)/indexer/sitefinder: $(o)/indexer/sitefinder.o $(LIBINDEXER) $(LIBSH)
endif

ifdef CONFIG_WEIGHTS
PROGS+=$(o)/indexer/weights
$(o)/indexer/weights: $(o)/indexer/weights.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/weights: LIBS+=-lm
endif

ifdef CONFIG_SHEPHERD_PROTOCOL
PROGS+=$(o)/indexer/iconnect $(o)/indexer/feedback-gath
$(o)/indexer/iconnect: $(o)/indexer/iconnect.o $(o)/gather/shepherd/protocol.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/feedback-gath: $(o)/indexer/feedback-gath.o $(o)/gather/shepherd/protocol.o $(LIBINDEXER) $(LIBSH)
endif

ifdef CONFIG_IMAGES_DUP
PROGS+=$(o)/indexer/mergeimages
$(o)/indexer/mergeimages: $(o)/indexer/mergeimages.o $(LIBINDEXER) $(LIBIMAGES) $(LIBSH)
endif

ifdef CONFIG_IMAGES_SIM
PROGS+=$(o)/indexer/imagesigs
$(o)/indexer/imagesigs: $(o)/indexer/imagesigs.o $(LIBINDEXER) $(LIBIMAGES) $(LIBSH)
endif

endif

LIBINDEXER_MODS=iconfig access fetch getbuck resolve
ifdef CONFIG_SITES
LIBINDEXER_MODS+=sites
endif

$(o)/indexer/libindexer.a: $(addsuffix .o,$(addprefix $(o)/indexer/,$(LIBINDEXER_MODS)))
$(o)/indexer/libindexer.so: $(addsuffix .oo,$(addprefix $(o)/indexer/,$(LIBINDEXER_MODS)))
$(o)/indexer/libindexer.pc: $(LIBSH)

$(o)/indexer/scanner: $(o)/indexer/scanner.o $(o)/indexer/matcher.o $(o)/indexer/alphabet.o $(o)/indexer/lexicon.o \
	$(o)/indexer/getbuck.o $(LIBINDEXER) $(LIBFILTER) $(LIBANAL) $(LIBLANG) $(LIBCHARSET) $(LIBCUSTOM) $(LIBSH)
$(o)/indexer/scanner: LIBS+=-lm
$(o)/indexer/mergefp: $(o)/indexer/mergefp.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/mergesums: $(o)/indexer/mergesums.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/mergesigns: $(o)/indexer/mergesigns.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/fpsort: $(o)/indexer/fpsort.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/merger: $(o)/indexer/merger.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/labelsort: $(o)/indexer/labelsort.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/mklex: $(o)/indexer/mklex.o $(o)/indexer/lexicon.o $(o)/indexer/alphabet.o $(LIBINDEXER) $(LIBLANG) $(LIBCHARSET) $(LIBCUSTOM) $(LIBSH)
$(o)/indexer/chewer: $(o)/indexer/chewer.o $(o)/indexer/lexicon.o $(o)/indexer/alphabet.o $(LIBINDEXER) $(LIBANAL) $(LIBCHARSET) $(LIBCUSTOM) $(LIBSH)
$(o)/indexer/chewer: LIBS+=-lm
$(o)/indexer/wsort: $(o)/indexer/wsort.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/ssort: $(o)/indexer/ssort.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/psort: $(o)/indexer/psort.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/mkgraph: $(o)/indexer/mkgraph.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/backlinker: $(o)/indexer/backlinker.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/backlinker: LIBS+=-lm
$(o)/indexer/reftexts: $(o)/indexer/reftexts.o $(LIBINDEXER) $(LIBCHARSET) $(LIBSH)
$(o)/indexer/reftexts: LIBS+=-lm
$(o)/indexer/lexmap-test: $(o)/indexer/lexmap-test.o $(o)/indexer/lexicon.o $(o)/indexer/alphabet.o $(LIBCHARSET) $(LIBSH)
$(o)/indexer/lexorder: $(o)/indexer/lexorder.o $(LIBINDEXER) $(o)/indexer/lexicon.o $(LIBLANG) $(LIBCHARSET) $(LIBSH)
$(o)/indexer/lexorder: LIBS+=-lm
$(o)/indexer/lexsort: $(o)/indexer/lexsort.o $(LIBINDEXER) $(o)/indexer/lexicon.o $(LIBCHARSET) $(LIBSH)
$(o)/indexer/lexfreq: $(o)/indexer/lexfreq.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/ireport: $(o)/indexer/ireport.o $(LIBINDEXER) $(LIBLANG) $(LIBCHARSET) $(LIBCUSTOM) $(LIBSH)
$(o)/indexer/keywords: $(o)/indexer/keywords.o $(o)/indexer/lexicon.o $(o)/indexer/alphabet.o $(LIBINDEXER) $(LIBCHARSET) $(LIBSH)
$(o)/indexer/seal: $(o)/indexer/seal.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/black-gen: $(o)/indexer/black-gen.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/attrsort: $(o)/indexer/attrsort.o $(LIBINDEXER) $(LIBSH)

$(o)/indexer/getbuck-t: $(o)/indexer/getbuck-tt.o $(LIBINDEXER) $(LIBSH)
$(o)/indexer/fetch-t: $(o)/indexer/fetch-tt.o $(LIBINDEXER) $(LIBSH)

=== lang/Makefile ===
# Makefile for the Sherlock Language Processing Modules (c) 2003--2007 Martin Mares <mj@ucw.cz>

DIRS+=lang
LIBLANG_CONFIGS=lang

# The basic modules are compiled even when CONFIG_LANG is not enabled
LIBLANG_MODS=lang
LIBLANG_INCLUDES=lang.h

ifdef CONFIG_LANG

LIBLANG_PROGS=$(o)/lang/stem-table-gen $(o)/lang/stemtest $(o)/lang/stem-dict-gen
LIBLANG_MODS+=stemmer stem-porter stem-table stem-dict syndict

ifdef CONFIG_LANG_DETECT
LIBLANG_PROGS+=$(o)/lang/lang-tables
LIBLANG_CONFIGS+=lang-detect
LIBLANG_MODS+=detect
LIBLANG_INCLUDES+=detect.h
endif

API_LIBS+=liblang
API_INCLUDES+=$(o)/lang/.include-stamp
$(o)/lang/.include-stamp: $(addprefix $(s)/lang/,$(LIBLANG_INCLUDES))
$(o)/lang/.include-stamp: IDST=lang
run/lib/pkgconfig/liblang.pc: $(o)/lang/liblang.pc

endif

PROGS+=$(LIBLANG_PROGS)
CONFIGS+=$(LIBLANG_CONFIGS)

$(o)/lang/liblang.a: $(addsuffix .o,$(addprefix $(o)/lang/,$(LIBLANG_MODS)) $(LIBLANG_EXTRAS))
$(o)/lang/liblang.so: $(addsuffix .oo,$(addprefix $(o)/lang/,$(LIBLANG_MODS)) $(LIBLANG_EXTRAS))
$(o)/lang/liblang.pc: $(LIBUCW) $(LIBCHARSET)

$(o)/lang/stemtest: $(o)/lang/stemtest.o $(LIBLANG) $(LIBCHARSET) $(LIBUCW)
$(o)/lang/lang-tables: $(o)/lang/lang-tables.o $(o)/indexer/getbuck.o $(o)/indexer/iconfig.o $(LIBFILTER) $(LIBLANG) $(LIBCHARSET) $(LIBSH)
$(o)/lang/stem-table-gen: $(o)/lang/stem-table-gen.o $(LIBUCW)
$(o)/lang/stem-dict-gen: $(o)/lang/stem-dict-gen.o $(LIBCHARSET) $(LIBUCW)

INSTALL_TARGETS+=install-liblang
install-liblang:
	install -d -m 755 $(DESTDIR)$(INSTALL_INCLUDE_DIR)/lang $(DESTDIR)$(INSTALL_LIB_DIR) $(DESTDIR)$(INSTALL_PKGCONFIG_DIR) $(DESTDIR)$(INSTALL_BIN_DIR) $(DESTDIR)$(INSTALL_CONFIG_DIR)
	install -m 755 $(LIBLANG_PROGS) $(DESTDIR)$(INSTALL_BIN_DIR)
	install -m 644 $(addprefix run/$(CONFIG_DIR)/,$(LIBLANG_CONFIGS)) $(DESTDIR)$(INSTALL_CONFIG_DIR)
	install -m 644 $(addprefix run/include/lang/,$(LIBLANG_INCLUDES)) $(DESTDIR)$(INSTALL_INCLUDE_DIR)/lang
	install -m 644 run/lib/liblang.$(LS) $(DESTDIR)$(INSTALL_LIB_DIR)
	install -m 644 run/lib/pkgconfig/liblang.pc $(DESTDIR)$(INSTALL_PKGCONFIG_DIR)

.PHONY: install-liblang

=== search/Makefile ===
# Makefile for the Sherlock Search Server (c) 2001--2007 Martin Mares <mj@ucw.cz>

DIRS+=search
PROGS+=$(o)/search/sherlockd
CONFIGS+=sherlockd

SS_OBJS=sherlockd.o config.o dbase.o reply.o query.o lex.o parse.tab.o cards.o words.o strings.o memory.o \
	refs.o cmds.o lexicon.o spell.o vocabolario.o fulltext.o
SI_OBJS=alphabet.o

ifdef CONFIG_SITES
SI_OBJS+=sites.o
endif

ifdef CONFIG_IMAGES_SIM
SS_OBJS+=images.o
SS_IMAGES=$(LIBIMAGES)
endif

$(o)/search/sherlockd: $(addprefix $(o)/search/,$(SS_OBJS)) $(addprefix $(o)/indexer/,$(SI_OBJS)) $(SS_IMAGES) $(LIBLANG) $(LIBCHARSET) $(LIBCUSTOM) $(LIBSH)

$(o)/search/lex.o: $(o)/search/parse.tab.h
$(o)/search/parse.tab.o $(o)/search/parse.tab.oo: CWARNS+=-Wno-sign-compare -Wno-redundant-decls -Wno-undef

$(addprefix $(o)/search/,words.o refs.o cards.o): COPT+=$(COPT2)

$(o)/search/parse.tab.h: $(o)/search/parse.tab.c
	$(Q)touch $@

$(o)/search/parse.tab.c: $(s)/search/parse.y
	$(M)BISON $^
	$(Q)bison -dv $^ -o $@

=== ucw/Makefile ===
# Makefile for the UCW Library (c) 1997--2009 Martin Mares <mj@ucw.cz>

DIRS+=ucw
LIBUCW=$(o)/ucw/libucw.pc

ifdef CONFIG_UCW_UTILS
include $(s)/ucw/utils/Makefile
endif

LIBUCW_MODS= \
	threads \
	alloc alloc_str realloc bigalloc mempool mempool-str mempool-fmt eltpool \
	mmap partmap hashfunc \
	slists simple-lists bitsig \
	log log-stream log-file log-syslog log-conf proctitle tbf \
	conf-alloc conf-dump conf-input conf-intr conf-journal conf-parse conf-section \
	ipaccess \
	profile \
	fastbuf ff-binary ff-string ff-printf ff-unicode ff-stkstring \
	fb-file carefulio fb-mem fb-temp tempfile fb-mmap fb-limfd fb-buffer fb-grow fb-pool fb-atomic fb-param fb-socket \
	char-cat char-upper char-lower unicode stkstring \
	wildmatch regex \
	prime primetable random timer randomkey \
	bit-ffs bit-fls \
	url \
	mainloop exitstatus runcmd sighandler \
	lizard lizard-safe adler32 \
	md5 sha1 sha1-hmac \
	base64 base224 \
	sync \
	qache \
	string str-esc str-split str-match str-imatch str-hex \
	bbuf \
	getopt

LIBUCW_MAIN_INCLUDES= \
	lib.h threads.h \
	mempool.h \
	clists.h slists.h simple-lists.h \
	string.h stkstring.h unicode.h chartype.h regex.h \
	wildmatch.h \
	unaligned.h prefetch.h \
	bbuf.h gbuf.h bitarray.h bitsig.h \
	hashfunc.h hashtable.h \
	heap.h binheap.h binheap-node.h \
	redblack.h \
	prime.h \
	bitops.h \
	conf.h getopt.h ipaccess.h \
	profile.h \
	fastbuf.h lfs.h ff-unicode.h ff-binary.h \
	url.h \
	mainloop.h \
	lizard.h \
	md5.h \
	base64.h base224.h \
	qache.h \
	kmp.h kmp-search.h binsearch.h \
	partmap.h

ifdef CONFIG_UCW_THREADS
# Some modules require threading
LIBUCW_MODS+=threads-conf workqueue asio
LIBUCW_MAIN_INCLUDES+=workqueue.h semaphore.h asio.h
endif

ifdef CONFIG_UCW_FB_DIRECT
LIBUCW_MODS+=fb-direct
endif

ifdef CONFIG_OWN_GETOPT
include $(s)/ucw/getopt/Makefile
endif

LIBUCW_INCLUDES=$(LIBUCW_MAIN_INCLUDES)

include $(s)/ucw/sorter/Makefile
include $(s)/ucw/doc/Makefile

LIBUCW_MOD_PATHS=$(addprefix $(o)/ucw/,$(LIBUCW_MODS))

$(o)/ucw/libucw.a: $(addsuffix .o,$(LIBUCW_MOD_PATHS))
$(o)/ucw/libucw-pic.a: $(addsuffix .oo,$(LIBUCW_MOD_PATHS))
$(o)/ucw/libucw.so: $(addsuffix .oo,$(LIBUCW_MOD_PATHS))

$(o)/ucw/hashfunc.o $(o)/ucw/hashfunc.oo: CFLAGS += -funroll-loops
$(o)/ucw/lizard.o: CFLAGS += $(COPT2) -funroll-loops

$(o)/ucw/conf-test: $(o)/ucw/conf-test.o $(LIBUCW)
$(o)/ucw/lfs-test: $(o)/ucw/lfs-test.o $(LIBUCW)
$(o)/ucw/hash-test: $(o)/ucw/hash-test.o $(LIBUCW)
$(o)/ucw/hashfunc-test: $(o)/ucw/hashfunc-test.o $(LIBUCW)
$(o)/ucw/asort-test: $(o)/ucw/asort-test.o $(LIBUCW)
$(o)/ucw/redblack-test: $(o)/ucw/redblack-test.o $(LIBUCW)
$(o)/ucw/binheap-test: $(o)/ucw/binheap-test.o $(LIBUCW)
$(o)/ucw/lizard-test: $(o)/ucw/lizard-test.o $(LIBUCW)
$(o)/ucw/kmp-test: $(o)/ucw/kmp-test.o $(LIBUCW)
ifdef CONFIG_CHARSET
$(o)/ucw/kmp-test: $(LIBCHARSET)
endif
$(o)/ucw/ipaccess-test: $(o)/ucw/ipaccess-test.o $(LIBUCW)
$(o)/ucw/trie-test: $(o)/ucw/trie-test.o $(LIBUCW)

TESTS+=$(addprefix $(o)/ucw/,regex.test unicode.test hash-test.test mempool.test stkstring.test \
    slists.test bbuf.test kmp-test.test getopt.test ff-unicode.test eltpool.test \
    fb-socket.test trie-test.test string.test sha1.test asort-test.test binheap-test.test \
    redblack-test.test fb-file.test fb-grow.test fb-pool.test fb-atomic.test \
    fb-limfd.test fb-temp.test fb-mem.test fb-buffer.test fb-mmap.test url.test)

$(o)/ucw/regex.test: $(o)/ucw/regex-t
$(o)/ucw/unicode.test: $(o)/ucw/unicode-t
$(o)/ucw/hash-test.test: $(o)/ucw/hash-test
$(o)/ucw/mempool.test: $(o)/ucw/mempool-t $(o)/ucw/mempool-fmt-t $(o)/ucw/mempool-str-t
$(o)/ucw/stkstring.test: $(o)/ucw/stkstring-t
$(o)/ucw/bitops.test: $(o)/ucw/bit-ffs-t $(o)/ucw/bit-fls-t
$(o)/ucw/slists.test: $(o)/ucw/slists-t
$(o)/ucw/kmp-test.test: $(o)/ucw/kmp-test
$(o)/ucw/bbuf.test: $(o)/ucw/bbuf-t
$(o)/ucw/getopt.test: $(o)/ucw/getopt-t
$(o)/ucw/ff-unicode.test: $(o)/ucw/ff-unicode-t
$(o)/ucw/eltpool.test: $(o)/ucw/eltpool-t
$(o)/ucw/string.test: $(o)/ucw/str-hex-t $(o)/ucw/str-esc-t
$(o)/ucw/sha1.test: $(o)/ucw/sha1-t $(o)/ucw/sha1-hmac-t
$(o)/ucw/trie-test.test: $(o)/ucw/trie-test
$(o)/ucw/asort-test.test: $(o)/ucw/asort-test
$(o)/ucw/binheap-test.test: $(o)/ucw/binheap-test
$(o)/ucw/redblack-test.test: $(o)/ucw/redblack-test
$(addprefix $(o)/ucw/fb-,file.test grow.test pool.test socket.test atomic.test \
	limfd.test temp.test mem.test buffer.test mmap.test): %.test: %-t
$(o)/ucw/url.test: $(o)/ucw/url-t

ifdef CONFIG_UCW_THREADS
TESTS+=$(addprefix $(o)/ucw/,asio.test)
$(o)/ucw/asio.test: $(o)/ucw/asio-t
endif

# The version of autoconf.h that is a part of the public API needs to have
# the internal symbols filtered out, so we generate ucw/autoconf.h in the
# configure script and let the public config.h refer to <ucw/autoconf.h>
# instead of plain "autoconf.h".

API_LIBS+=libucw
API_INCLUDES+=$(o)/ucw/.include-stamp
$(o)/ucw/.include-stamp: $(addprefix $(s)/ucw/,$(LIBUCW_INCLUDES)) $(o)/ucw/autoconf.h
	$(Q)$(BUILDSYS)/install-includes $(<D) run/include/ucw $(LIBUCW_INCLUDES)
	$(Q)$(BUILDSYS)/install-includes $(o)/ucw run/include/ucw autoconf.h
	$(Q)sed -e 's/^#include "autoconf\.h"/#include <ucw\/autoconf.h>/' <$(s)/ucw/config.h >run/include/ucw/config.h
	$(Q)touch $@
run/lib/pkgconfig/libucw.pc: $(o)/ucw/libucw.pc

ifdef CONFIG_UCW_PERL
include $(s)/ucw/perl/Makefile
endif

ifdef CONFIG_UCW_SHELL_UTILS
include $(s)/ucw/shell/Makefile
endif

CONFIGS+=libucw

INSTALL_TARGETS+=install-libucw
install-libucw:
	install -d -m 755 $(DESTDIR)$(INSTALL_LIB_DIR) $(DESTDIR)$(INSTALL_INCLUDE_DIR)/ucw/ $(DESTDIR)$(INSTALL_PKGCONFIG_DIR) $(DESTDIR)$(INSTALL_CONFIG_DIR)
	install -m 644 $(addprefix run/include/ucw/,$(LIBUCW_MAIN_INCLUDES) autoconf.h config.h) $(DESTDIR)$(INSTALL_INCLUDE_DIR)/ucw/
	install -m 644 run/lib/pkgconfig/libucw.pc $(DESTDIR)$(INSTALL_PKGCONFIG_DIR)
	install -m 644 run/lib/libucw.$(LS) $(DESTDIR)$(INSTALL_LIB_DIR)
	install -m 644 run/$(CONFIG_DIR)/libucw $(DESTDIR)$(INSTALL_CONFIG_DIR)

.PHONY: install-libucw

=== utils/Makefile ===
# Miscellaneous utilities

DIRS+=utils
UTILS=cs2cs objdump idxdump scheduler sizer query shcp \
	dump-card index-version \
	configtest bgrep sched-control send-indices black-control send-mail locker check-indexer-input

ifdef CONFIG_SEARCH
UTILS+=skeeper scontrol check-sherlockd
endif

ifdef CONFIG_GATHERER
UTILS+=checker gcontrol
endif

ifdef CONFIG_SHEPHERD
UTILS+=check-shepherd check-limit
$(o)/utils/check-shepherd: $(o)/utils/check-shepherd.o $(LIBSH)
endif

PROGS+=$(addprefix $(o)/utils/,$(UTILS))

$(o)/utils/cs2cs: $(o)/utils/cs2cs.o $(LIBCHARSET) $(LIBSH)
$(o)/utils/objdump: $(o)/utils/objdump.o $(o)/utils/dumpconfig.o $(LIBLANG) $(LIBCHARSET) $(LIBSH)
$(o)/utils/idxdump: $(o)/utils/idxdump.o $(o)/utils/dumpconfig.o $(o)/indexer/iconfig.o $(LIBLANG) $(LIBCUSTOM) $(LIBCHARSET) $(LIBSH)
$(o)/utils/check-sherlockd: $(o)/utils/check-sherlockd.o $(LIBSH)
$(o)/utils/sizer: $(o)/utils/sizer.o $(LIBSH)
$(o)/utils/shcp: $(o)/utils/shcp.o $(LIBSH)
$(o)/utils/index-version: $(o)/utils/index-version.o $(LIBSH)
$(o)/utils/bgrep: $(o)/utils/bgrep.o $(LIBSH)
$(o)/utils/check-indexer-input: $(o)/utils/check-indexer-input.o $(LIBSH)

ifdef CONFIG_WATSON
include $(s)/utils/watson/Makefile
endif

include $(s)/utils/bench/relevance/Makefile
include $(s)/utils/bench/speed/Makefile

=== customs/bare/Makefile ===
# Stub Makefile for custom modules in the bare version of Sherlock
DIRS+=customs/bare/lib
CUSTOM_LIB_MODULES+=$(o)/customs/bare/lib/custom

=== customs/libsonly/Makefile ===
# Stub Makefile for custom modules

extras:: $(LIBUCW)

ifdef CONFIG_CHARSET
extras:: $(LIBCHARSET)
endif

ifdef CONFIG_SHERLOCK_LIB
extras:: $(LIBSH)
endif

ifdef CONFIG_IMAGES
extras:: $(LIBIMAGES)
endif

ifdef CONFIG_LANG
extras:: $(LIBLANG)
endif

ifdef CONFIG_XML
extras:: $(LIBSHXML)
endif

=== debian/changelog ===
holmes (4.0) stable; urgency=low

  A huge release moving most of the features from the commercial version to
  the free version.  The following new major features are now supported:

      * Site compression (the search server may only show the best 2 pages
	from one domain).
      * Automatic page ranking (based on the links between the pages). 

      * New intelligent gatherer (it chooses which pages to gather according
	to their ranks, it is much faster and more scalable, and it can
	refresh pages more often than the old gatherer from before v4.0).
      * Splitting the index into independent areas (one search engine for a
	number of domains). 

      * Extended image search: detection of near-duplicate images and
	searching for similar images.
      * Gathering audio files (in the MP3 and OGG format) and indexing their
	ID3 tags.

  Notable minor features include:

      * Added parsers for ZIP files (processes the largest file from the
	archive), and for XHTML and WML files.
      * The indexer now supports multiple sources.
      * The indexer resolver has been parallelized.
      * Support for spelling typos caused by a wrong keybord layout.
      * Language recognizer has acquired a tunable threshold, below which
        the recognizer admits that it failed to recognize the language.
	The default language tables now also include Russian.

  Besides these changes, the codebase has been cleaned up and better separated
  to a general UCW library and the actual search engine.  We have cleaned up
  the interfaces of the UCW library to make it easier to use them in other
  projects. Some of the changes were not backward compatible, but it should be
  very easy to fix the callers.  Notable new library features include:

      * The generic sorter module has been completely rewritten, the new
	version is much faster and more general. It now lives in
	lib/sorter/sorter.h, the old interface lib/sorter.h is gone. The array
	sorter (lib/arraysort.h) now has a more powerful sibling in
	lib/sorter/array.h, which is well suited for sorting of large arrays.
      * A lot of new documentation has been written for the UCW library.
      * New logging system capable of logging to multiple streams.
      * The build system now supports both building locally in the `run'
        directory and building for installation to a stable location.
      * We now use pkg-config to build libraries (and the .pc files are
	installed as a part of the library API), so the ever recurring
	problems with ordering of linker parameters should be gone.
      * A new fastbuf backend fb-direct has been added for direct I/O on
	files.  Another fastbuf backend fb-pool can take care of writing to a
	string allocated in a mempool.  The fb-file fastbuf backend is now
	able to optimize buffering for backward reading and intensive seeking.
      * Added a module for asynchronous direct I/O on files (lib/asio.h).

 -- Martin Mares <mj@ucw.cz>  Thu, 26 Jul 2007 11:27:31 +0200

holmes (3.11) stable; urgency=low

  Incompatible:

      * Changed format of Watson configuration files and location of downloaded
        and parsed logs.
      * Attributes are not longer limited to MAX_ATTR_SIZE.

  Libraries:

      * The libucw and libsh no longer define the following types: sbyte, word,
        sword and addr_int_t. Please use s8, u16, s16 and uintptr_t instead.
      * Fastbufs now work better on unseekable files. The seek callback returns
        success, bseek() and bsetpos() dies if seek fails, bfilesize() returns
        -1 if the file is unseekable.
      * lib/fastbuf.h no longer includes <stdio.h>. If you need SEEK_xxx, please
        include <stdio.h> or <unistd.h> yourself. If you need EOF, please use
        a test for a negative number instead as stdio EOF doesn't have anything
        in common with the fixed value of -1 used by the fastbufs.
      * Fastbuf functions for reading and writing of multi-byte numbers have been
        moved to lib/ff-binary.h. Specific number endianity can be requested.
      * Unaligned access macros have been replaced by functions (old names kept
        for compatibility) and they also have variants with specific endianity.
        GET_U32_BE16 and GET_U32_16 have been removed as they are no longer used.
      * Memory pools now support growing of the last allocated item and
        saving/restoring states.
      * Libgath has been split to libgath (without complex dependencies),
        libparse (various content parsers) and libproto (dowloader).

 -- Robert Spalek <robert@ucw.cz>  Thu, 26 Apr 2007 20:20:35 -0800

holmes (3.10.1) stable; urgency=low

  * Support for custom spelling sequences (for example double-letter
    equivalents in Polish language).
  * Added the "raw" analyzer for filtering of HTML documents with specific
    substrings in their unparsed content.
  * Better threading support in libucw and libsh.
  * Improved bucket interface in libsh.

 -- Martin Mares <mj@ucw.cz>  Mon, 18 Dec 2006 14:26:35 +0100

holmes (3.10) stable; urgency=low

  * Many optimizations in the indexer: resolver, ref-texts and everything related
    to link graphs is now significantly faster. The scanner is now able to run in
    multiple threads, achieving speedup almost 2 on a 2-way SMP system.
  * In addition to subindices (handled by different search servers), every (sub)index
    can be now split to several slices, handled by different threads of a single
    search server in parallel.
  * Added a general library for processing of images, capable of reading JPEG,
    PNG and GIF, writing JPEG and PNG (and optionally everything supported
    by GraphicsMagick) and performing basic operations like scaling really
    quickly. Added an image gatherer based on this library.
  * Basic libraries (libucw, liblang, libfilter and libanalyser) are now thread-safe.
    See lib/THREADS for details.

  Minor:

  * Documented adding of new charsets and languages: doc/charsets and doc/lang-tables.


=== debian/control ===
Source: holmes
Section: text
Priority: extra
Maintainer: Robert Spalek <robert@ucw.cz>
Standards-Version: 3.5.6.1
Build-Depends: perl, zlib1g-dev

Package: holmes
Architecture: any
Depends: perl (>= 5.6), ${shlibs:Depends}
Suggests: gnuplot
Description: Universal Search Engine
 A freely distributable version of the Sherlock Holmes search engine -- a
 system for gathering and indexing of textual data (text files, web pages,
 ...), both locally and over the network.
